



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>函数和常用模块【day05】：不同目录间进行模块调用（八）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">函数和常用模块【day05】：不同目录间进行模块调用（八）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-24 17:35:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>本节内容</h2>
<p>1、背景</p>
<p>2、函数功能解释</p>
<p>3、绝对路径和相对路径</p>
<p>4、不同目录间进行模块调用</p>
<h2>一、背景</h2>
<p>　　之前写了软件开发目录规范这篇博客，相信很多人都已经知道，我们在写程序时需要遵循一定的规范，不然，就算很简答的逻辑程序的代码，读起来会很费劲，占用了我们大量的时间，但是，我们一旦用了这样的规范目录，我们怎么去愉快的进行模块之前的相互导入呢？这就不得不说我们今天讨论的两个概念:绝对路径和相对路径。</p>
<h2>二、函数功能解释</h2>
<h3><strong>1、__file__</strong></h3>
<p>功能：返回自身文件的相对路径</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
<div>10</div>
</td>
<td>
<div>
<div><code>#atm.py中的代码</code></div>
<div><code>print</code><code>(__file__)</code></div>
<div>&nbsp;</div>
<div><code>#pycharm的执行结果</code></div>
<div><code>D:\Python\Python35\python.exe D:</code><code>/</code><code>PycharmProjects</code><code>/</code><code>51homework</code><code>/</code><code>Atm</code><code>/</code><code>bin</code><code>/</code><code>atm.py</code></div>
<div><code>D:</code><code>/</code><code>PycharmProjects</code><code>/</code><code>51homework</code><code>/</code><code>Atm</code><code>/</code><code>bin</code><code>/</code><code>atm.py&nbsp;&nbsp;</code><code>#打印出绝对路径</code></div>
<div>&nbsp;</div>
<div><code>#从cmd执行atm.py&nbsp;</code></div>
<div><code>D:\PycharmProjects\</code><code>51homework</code><code>&gt;python Atm</code><code>/</code><code>bin</code><code>/</code><code>atm.py&nbsp;</code></div>
<div><code>Atm</code><code>/</code><code>bin</code><code>/</code><code>atm.py&nbsp;&nbsp;&nbsp;</code><code>#打印的是相对路径</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>从上面看，为什么pycharm中执行的结果是绝对路径，而从cmd调用python命令时显示的却是相对路径?你从pycharm的执行结果可以看出，在pycharm执行atm.py文件时，是从绝对路径下去执行的，而你从cmd下去执行的时候，是你选择可以在哪个路径下执行，而__file__表示的是相对路径，所以在哪个路径下，就打印哪个路径。</p>
<h3><strong>2、os.path.abs()</strong></h3>
<p>功能：返回自身文件的绝对路径</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
</td>
<td>
<div>
<div><code>#atm.py的文件代码</code></div>
<div><code>import</code>&nbsp;<code>os</code></div>
<div><code>print</code><code>(os.path.abspath(__file__))</code></div>
<div><code>#在cmd中的执行结果</code></div>
<div><code>D:\PycharmProjects\</code><code>51homework</code><code>&gt;python Atm</code><code>/</code><code>bin</code><code>/</code><code>atm.py</code></div>
<div><code>D:\PycharmProjects\</code><code>51homework</code><code>\Atm\</code><code>bin</code><code>\atm.py&nbsp;&nbsp;</code><code>#获取atm.py的绝对路径</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<h3><strong>3、os.path.dirname()</strong></h3>
<p>功能：返回目录名，不需要文件名</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
</td>
<td>
<div>
<div><code>#atm.py的文件代码</code></div>
<div><code>import</code>&nbsp;<code>os</code></div>
<div><code>print</code><code>(os.path.dirname( os.path.abspath(__file__) ))</code></div>
<div><code>#在cmd中的执行结果</code></div>
<div><code>D:\PycharmProjects\</code><code>51homework</code><code>&gt;python Atm</code><code>/</code><code>bin</code><code>/</code><code>atm.py</code></div>
<div><code>D:\PycharmProjects\</code><code>51homework</code><code>\Atm\</code><code>bin</code>&nbsp;&nbsp;<code>#只返回目录名，不需要文件名</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<h3><strong>4、sys.path</strong></h3>
<p>功能：python环境的执行的环境变量</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
</td>
<td>
<div>
<div><code>#atm.py中的代码</code></div>
<div><code>import</code>&nbsp;<code>sys</code></div>
<div><code>print</code><code>(sys.path)</code></div>
<div><code>#cmd执行的结果</code></div>
<div><code>D:\PycharmProjects\</code><code>51homework</code><code>&gt;python Atm</code><code>/</code><code>bin</code><code>/</code><code>atm.py</code></div>
<div><code>[</code><code>'D:\\PycharmProjects\\51homework\\Atm\\bin'</code><code>,&nbsp;</code><code>'D:\\Python\\Python35\\python35.zip'</code><code>,</code></div>
<div><code>&nbsp;</code><code>'D:\\Python\\Python35\\DLLs'</code><code>,&nbsp;</code><code>'D:\\Python\\Python35\\lib'</code><code>,&nbsp;</code><code>'D:\\Python\\Python35'</code><code>,</code></div>
<div><code>'D:\\Python\\Python35\\lib\\site-packages'</code><code>]</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>注：执行路径是列表的形式打印出来的，所以sys.path数据类型是一个列表。</p>
<h2>三、绝对路径和相对路径</h2>
<h3><strong>1、绝对路径</strong></h3>
<p>绝对路径：从根目录为起点到你所在的目录。</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
</td>
<td>
<div>
<div><code>&gt;&gt;&gt;&nbsp;</code><code>import</code>&nbsp;<code>os</code></div>
<div><code>&gt;&gt;&gt; os.chdir(</code><code>"D:\\PycharmProjects\\51homework\\Atm\\bin\\"</code><code>)</code></div>
<div><code>&gt;&gt;&gt; os.listdir()</code></div>
<div><code>[</code><code>'atm.py'</code><code>,&nbsp;</code><code>'__init__.py'</code><code>]</code></div>
<div><code>&gt;&gt;&gt; os.path.abspath(</code><code>'atm.py'</code><code>)</code></div>
<div><code>'D:\\PycharmProjects\\51homework\\Atm\\bin\\atm.py'</code>&nbsp;&nbsp;&nbsp;<code>#是从D盘的这个根目录下来的</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<h3><strong>2、相对路径</strong></h3>
<p>相对路径：从一个目录为起点到你所在的目录。</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
</td>
<td>
<div>
<div><code>&gt;&gt;&gt;&nbsp;</code><code>import</code>&nbsp;<code>os</code></div>
<div><code>&gt;&gt;&gt; os.chdir(</code><code>"D:\\PycharmProjects\\51homework\\Atm\\bin\\"</code><code>)</code></div>
<div><code>&gt;&gt;&gt; os.listdir()</code></div>
<div><code>[</code><code>'atm.py'</code><code>,&nbsp;</code><code>'__init__.py'</code><code>]</code></div>
<div><code>&gt;&gt;&gt; os.path.dirname(</code><code>'atm.py'</code><code>)</code></div>
<div><code>''&nbsp;&nbsp;&nbsp;</code><code>#显示相对路径</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<h2>四、不同目录间进行模块调用</h2>
<h3><strong>1、添加环境变量</strong></h3>
<p>一般情况下，绝对路劲函数和相对路径函数是结合起来用的，特别是在不同目录之间相互调用彼此的模块。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/936656/201703/936656-20170329145746686-819833546.png" /></p>
<p>比如按以上层级：atm.py如果想调用其他模块中的代码，必须要跟atm.py是同级的，不信请看如下代码：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
</td>
<td>
<div>
<div><code>#atm.py中的代码</code></div>
<div><code>import</code>&nbsp;<code>sys</code></div>
<div><code>print</code><code>(sys.path)</code></div>
<div><code>#cmd执行的结果</code></div>
<div><code>D:\PycharmProjects\</code><code>51homework</code><code>&gt;python Atm</code><code>/</code><code>bin</code><code>/</code><code>atm.py</code></div>
<div><code>[</code><code>'D:\\PycharmProjects\\51homework\\Atm\\bin'</code><code>,&nbsp;</code><code>'D:\\Python\\Python35\\python35.zip'</code><code>,</code></div>
<div><code>&nbsp;</code><code>'D:\\Python\\Python35\\DLLs'</code><code>,&nbsp;</code><code>'D:\\Python\\Python35\\lib'</code><code>,&nbsp;</code><code>'D:\\Python\\Python35'</code><code>,</code></div>
<div><code>'D:\\Python\\Python35\\lib\\site-packages'</code><code>]</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>只到'D:\\PycharmProjects\\51homework\\Atm\\bin'这一层，其他的层级无法调用。那怎么办呐？</p>
<p>步骤如下：</p>
<ol><li>获取Atm的绝对路径</li>
<li>添加到环境变量中</li></ol>
<p>代码如下：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
<div>10</div>
<div>11</div>
<div>12</div>
<div>13</div>
<div>14</div>
</td>
<td>
<div>
<div><code>#atm.py中的代码</code></div>
<div><code>import</code>&nbsp;<code>os,sys</code></div>
<div><code>BASE_DIR&nbsp;</code><code>=</code>&nbsp;<code>os.path.dirname( os.path.dirname( os.path.abspath(__file__) ) )&nbsp;</code><code>#Atm的绝对路径</code></div>
<div><code>print</code><code>(BASE_DIR)</code></div>
<div><code>sys.path.append(BASE_DIR)&nbsp;&nbsp;</code><code>#添加到环境变量中</code></div>
<div><code>print</code><code>(sys.path)</code></div>
<div>&nbsp;</div>
<div><code>#cmd执行结果</code></div>
<div><code>D:\PycharmProjects\</code><code>51homework</code><code>&gt;python Atm</code><code>/</code><code>bin</code><code>/</code><code>atm.py&nbsp;&nbsp;&nbsp;</code><code>#执行atm.py文件</code></div>
<div><code>D:\PycharmProjects\</code><code>51homework</code><code>\Atm&nbsp;&nbsp;&nbsp;</code><code>#打印Atm的绝对路径</code></div>
<div><code>[</code><code>'D:\\PycharmProjects\\51homework\\Atm\\bin'</code><code>,&nbsp;</code><code>'D:\\Python\\Python35\\python35.zip'</code><code>,</code></div>
<div><code>'D:\\Python\\Python35\\DLLs'</code><code>,&nbsp;</code><code>'D:\\Python\\Python35\\lib'</code><code>,&nbsp;</code><code>'D:\\Python\\Python35'</code><code>,</code></div>
<div><code>&nbsp;</code><code>'D:\\Python\\Python35\\lib\\site-packages'</code><code>,</code></div>
<div><code>&nbsp;</code><code>'D:\\PycharmProjects\\51homework\\Atm'</code><code>]&nbsp;&nbsp;&nbsp;</code><code>#Atm的绝对路径已经添加到环境变量中</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<h3><strong>2、调用其他模块</strong></h3>
<p>接下来就可以顺利的进行不同目录下，模块之间的调用了</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
<div>10</div>
<div>11</div>
<div>12</div>
<div>13</div>
<div>14</div>
</td>
<td>
<div>
<div><code>#atm.py中的代码</code></div>
<div><code>import</code>&nbsp;<code>os,sys</code></div>
<div><code>BASE_DIR&nbsp;</code><code>=</code>&nbsp;<code>os.path.dirname( os.path.dirname( os.path.abspath(__file__) ) )</code></div>
<div><code>sys.path.append(BASE_DIR)</code></div>
<div><code>from</code>&nbsp;<code>core&nbsp;</code><code>import</code>&nbsp;<code>main&nbsp;&nbsp;&nbsp;</code><code>#调用core中的main模块</code></div>
<div><code>main.sayhi()&nbsp;&nbsp;&nbsp;</code><code>#调用main模块中sayhi函数</code></div>
<div>&nbsp;</div>
<div><code>#main.py中代码</code></div>
<div><code>def</code>&nbsp;<code>sayhi():</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>print</code><code>(</code><code>"hello word"</code><code>)</code></div>
<div>&nbsp;</div>
<div><code>#cmd执行的结果</code></div>
<div><code>D:\PycharmProjects\</code><code>51homework</code><code>&gt;python Atm</code><code>/</code><code>bin</code><code>/</code><code>atm.py</code></div>
<div><code>hello word</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/or930w93.html">ASP&period;NET Aries 入门开发教程6：列表数据表格的格式化处理及行内编辑</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1lo158.html">BarTender如何将条码下的数字嵌入到条码中</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mrl6r9.html">原生js编写的安全色拾色器</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zw4318.html">javax&period;net&period;ssl&period;SSLHandshakeException&colon; Received fatal alert&colon; handshake&lowbar;failure 解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xxld09.html">robotframework笔记4</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1mm1j9.html">LCIS（m&ast;n&rpar; 最长公共上升子序列</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wvwlwq.html">python编码基础知识</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x1j7m8.html">poj 1564 Sum It Up【dfs&plus;去重】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn34d2q.html">Linux下安装oracle11g</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjyvnj8.html">JS &plus; HTml 时钟代码实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzvx048.html">201521123025 &amp;lt&semi;&amp;lt&semi;java程序设计&amp;gt&semi;&amp;gt&semi;第3周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jgo4x8.html">Scala 中的隐式转换和隐式参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpy0dvq.html">python爬取365好书中小说</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpeok39.html">B20J&lowbar;2243&lowbar;&lbrack;SDOI2011&rsqb;染色&lowbar;树链剖分&plus;线段树</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eynv4x9.html">Android 系统版本和API level的关系表</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk10oj8.html">Consideration about improving mathematics study</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jpnneq.html">windows网络编程中文 笔记（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvrej38.html">AS使用lombok注解报错：Annotation processors must be explicitly declared now&period; The following dependencies on the compile classpath are found to contain annotation processor&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1ry3l28.html">SpringBoot Web开发&lpar;4&rpar; Thymeleaf模板与freemaker</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjxmlz9.html">PHP之高性能I&sol;O框架：Libevent（三）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxdxxdj9.html">redis的优缺点</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj44x79.html">PAT 甲级 1135 Is It A Red-Black Tree</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwllnx9.html">PAT 1014 福尔摩斯的约会</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wkl6rq.html">Apache的Thrift引发的编译思考</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll727kq.html">Java 线程内 递归  Bug 一例</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyxlemq.html">linux系统centOS7下搭建redis集群中ruby版本过低问题的解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwl4px9.html">prettier &amp;amp&semi; codes format</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pweolk8.html">使用pygal&lowbar;maps&lowbar;world&period;i18n中数据画各大洲地图</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjkwde9.html">BZOJ2215&lbrack;Poi2011&rsqb;Conspiracy&mdash;&mdash;2-SAT&plus;tarjan缩点</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2z0p6q.html">BZOJ1828&lbrack;USACO 2010 Mar Gold 2&period;Barn Allocation&rsqb;&mdash;&mdash;贪心&plus;线段树</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
